<?php
namespace bwdcp_catproduct_namespace;

define( "BWDCP_ASFSK_ASSETS_PUBLIC_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/public" );
define( "BWDCP_ASFSK_ASSETS_ADMIN_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/admin" );
class Classbwdcpcatproduct {

	private static $_instance = null;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function bwdcp_admin_editor_scripts() {
		add_filter( 'script_loader_tag', [ $this, 'bwdcp_admin_editor_scripts_as_a_module' ], 10, 2 );
	}

	public function bwdcp_admin_editor_scripts_as_a_module( $tag, $handle ) {
		if ( 'bwdcp_catproduct_editor' === $handle ) {
			$tag = str_replace( '<script', '<script type="module"', $tag );
		}

		return $tag;
	}

	private function include_widgets_files() {
		require_once( __DIR__ . '/widgets/bwdcp-catproduct-widget.php' );
	}

	public function bwdcp_register_widgets() {
		// Its is now safe to include Widgets files
		$this->include_widgets_files();

		// Register WidgetsF
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdcpcatproduct_widgets());
	}

	// Register Category
	function bwdcp_add_elementor_widget_categories( $elements_manager ) {

		$elements_manager->add_category(
			'bwdcp-catproduct-category',
			[
				'title' => esc_html__( 'Product Category Carousel', 'bwdcp-catproduct-td' ),
				'icon' => 'eicon-person',
			]
		);
	}

	//css-js-link-here
	public function bwdcp_all_assets_for_the_public(){
		wp_enqueue_style( 'bwdcp-catproduct-owl-style', 'https://bwd-elementor-addons-pro.netlify.app/bwdcp-catproduct/owl.carousel.min.css', array(), '2.1', 'all' );
		wp_enqueue_style( 'bwdcp-catproduct_owl-default-style', 'https://bwd-elementor-addons-pro.netlify.app/bwdcp-catproduct/owl.theme.default.min.css', array(), '2.1', 'all' );
		wp_enqueue_style( 'bwdcp-catproduct-main-style', 'https://bwd-elementor-addons-pro.netlify.app/bwdcp-catproduct/main.css', array(), '2.1', 'all' );

		wp_enqueue_script( 'bwdcp-catproduct-owl-interactive', 'https://bwd-elementor-addons-pro.netlify.app/bwdcp-catproduct/owl.carousel.min.js', array('jquery'), '2.1', true );
		wp_enqueue_script( 'bwdcp-catproduct-main-interactive', 'https://bwd-elementor-addons-pro.netlify.app/bwdcp-catproduct/main.js', array('jquery'), '2.1', true );
	}

	//admin-icon
	public function bwdcp_all_assets_for_elementor_editor_admin(){
		$all_css_js_file = array(
            'bwdcp_catproduct_admin_main_css' => array('bwdcp_path_admin_define'=>BWDCP_ASFSK_ASSETS_ADMIN_DIR_FILE . '/icon.css'),
        );
        foreach($all_css_js_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdcp_path_admin_define'], null, '2.1', 'all');
        }
	}
	
	public function __construct() {
		// For public assets
		add_action('wp_enqueue_scripts', [$this, 'bwdcp_all_assets_for_the_public']);

		// For Elementor Editor
		add_action('elementor/editor/before_enqueue_scripts', [$this, 'bwdcp_all_assets_for_elementor_editor_admin']);
		
		// Register Category
		add_action( 'elementor/elements/categories_registered', [ $this, 'bwdcp_add_elementor_widget_categories' ] );

		// Register widgets
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'bwdcp_register_widgets' ] );

		// Register editor scripts
		add_action( 'elementor/editor/after_enqueue_scripts', [ $this, 'bwdcp_admin_editor_scripts' ] );
	}
}

// Instantiate Plugin Class
Classbwdcpcatproduct::instance();