<?php
namespace bwdcp_catproduct_namespace\Widgets;

use Elementor\Widget_Base;
use Elementor\Controls_Manager;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class bwdcpcatproduct_widgets extends Widget_Base {

	public function get_name() {
		return esc_html__( 'bwdcp-catproduct', 'bwdcp-catproduct-td' );
	}

	public function get_title() {
		return esc_html__( 'Product Category Carousel', 'bwdcp-catproduct-td' );
	}

	public function get_icon() {
		return 'eicon-product-categories bwdcp-catproduct-icon';
	}

	public function get_categories() {
		return [ 'bwdcp-catproduct-category' ];
	}

	protected function bwdcp_get_include_product_categories_options() {
		$categories = get_terms( array(
			'taxonomy'   => 'product_cat',
			'hide_empty' => false,
		) );

		$options = array();
		foreach ( $categories as $category ) {
			$options[ $category->term_id ] = $category->name;
		}

		return $options;
	}
	protected function bwdcp_get_exclude_product_categories_options() {
		$categories = get_terms( array(
			'taxonomy'   => 'product_cat',
			'hide_empty' => false,
		) );

		$options = array();
		foreach ( $categories as $category ) {
			$options[ $category->term_id ] = $category->name;
		}

		return $options;
	}
	protected function register_controls(){
		
		//tab-content
		$this->start_controls_section(
			'bwdcp_content_section',
			[
				'label' => esc_html__( 'All Style Here', 'bwdcp-catproduct-td' ),
				'tab' => Controls_Manager::TAB_CONTENT,
			]
		);

		//Select Style
		$this->add_control(
			'bwdcp_select_style_selection',
			[
				'label' => esc_html__( 'Select Style', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SELECT,
				'default' => '1',
				'options' => [
					'1' => esc_html__( 'Style 1', 'bwdcp-catproduct-td' ),
					'2' => esc_html__( 'Style 2', 'bwdcp-catproduct-td' ),
					'3' => esc_html__( 'Style 3', 'bwdcp-catproduct-td' ),
					'4' => esc_html__( 'Style 4', 'bwdcp-catproduct-td' ),
					'5' => esc_html__( 'Style 5', 'bwdcp-catproduct-td' ),
					'6' => esc_html__( 'Style 6', 'bwdcp-catproduct-td' ),
					'7' => esc_html__( 'Style 7', 'bwdcp-catproduct-td' ),
					'8' => esc_html__( 'Style 8', 'bwdcp-catproduct-td' ),
					'9' => esc_html__( 'Style 9', 'bwdcp-catproduct-td' ),
					'10' => esc_html__( 'Style 10', 'bwdcp-catproduct-td' ),
					'11' => esc_html__( 'Style 11', 'bwdcp-catproduct-td' ),
					'12' => esc_html__( 'Style 12', 'bwdcp-catproduct-td' ),
					'13' => esc_html__( 'Style 13', 'bwdcp-catproduct-td' ),
					'14' => esc_html__( 'Style 14', 'bwdcp-catproduct-td' ),
					'15' => esc_html__( 'Style 15', 'bwdcp-catproduct-td' ),
					'16' => esc_html__( 'Style 16', 'bwdcp-catproduct-td' ),
					'17' => esc_html__( 'Style 17', 'bwdcp-catproduct-td' ),
					'18' => esc_html__( 'Style 18', 'bwdcp-catproduct-td' ),
					'19' => esc_html__( 'Style 19', 'bwdcp-catproduct-td' ),
					'20' => esc_html__( 'Style 20', 'bwdcp-catproduct-td' ),
				],
			]
		);
		$this->end_controls_section();

		$this->start_controls_section(
			'bwdcp_catproduct_settings',
			[
				'label' => esc_html__( 'Category Settings', 'bwdcp-catproduct-td' ),
				'tab' => Controls_Manager::TAB_CONTENT,
			]
		);
		$this->add_control(
			'bwdcp_image',
			[
				'label' => esc_html__( 'Image', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Show', 'bwdcp-catproduct-td' ),
				'label_off' => esc_html__( 'Hide', 'bwdcp-catproduct-td' ),
				'return_value' => 'yes',
				'default' => 'yes',
			]
		);
		$this->add_control(
			'bwdcp_image_link',
			[
				'label' => esc_html__( 'Hide Image Link', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Show', 'bwdcp-catproduct-td' ),
				'label_off' => esc_html__( 'Hide', 'bwdcp-catproduct-td' ),
				'condition' => [
					'bwdcp_image' => 'yes',
				],
				'return_value' => 'yes',
				'default' => 'no',
			]
		);
		$this->add_control(
			'bwdcp_title',
			[
				'label' => esc_html__( 'Title', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Show', 'bwdcp-catproduct-td' ),
				'label_off' => esc_html__( 'Hide', 'bwdcp-catproduct-td' ),
				'return_value' => 'yes',
				'default' => 'yes',
			]
		);
		$this->add_control(
			'bwdcp_description',
			[
				'label' => esc_html__( 'Description', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Show', 'bwdcp-catproduct-td' ),
				'label_off' => esc_html__( 'Hide', 'bwdcp-catproduct-td' ),
				'return_value' => 'yes',
				'default' => 'no',
			]
		);
		$this->add_control(
			'bwdcp_button',
			[
				'label' => esc_html__( 'Button', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Show', 'bwdcp-catproduct-td' ),
				'label_off' => esc_html__( 'Hide', 'bwdcp-catproduct-td' ),
				'return_value' => 'yes',
				'default' => 'yes',
			]
		);
		$this->add_control(
			'bwdcp_button_text',
			[
				'label' => esc_html__( 'Value', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::TEXT,
				'default' => esc_html__( 'SHOP NOW', 'bwdcp-catproduct-td' ),
				'condition' => [
					'bwdcp_button' => 'yes',
				],
				'dynamic' => [
					'active' => true,
				],
			]
		);
		// 
		$this->add_control(
			'bwdcp_review',
			[
				'label' => esc_html__( 'Review', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Show', 'bwdcp-catproduct-td' ),
				'label_off' => esc_html__( 'Hide', 'bwdcp-catproduct-td' ),
				'return_value' => 'yes',
				'default' => 'yes',
			]
		);
		$this->add_control(
			'bwdcp_review_number',
			[
				'label' => esc_html__( 'Review Number', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Show', 'bwdcp-catproduct-td' ),
				'label_off' => esc_html__( 'Hide', 'bwdcp-catproduct-td' ),
				'return_value' => 'yes',
				'default' => 'yes',
			]
		);
		$this->end_controls_section();

		$this->start_controls_section(
			'bwdcp_query_content_section',
			[
				'label' => esc_html__( 'Category Query', 'bwdcp-catproduct-td' ),
				'tab' => Controls_Manager::TAB_CONTENT,
			]
		);
		$this->add_control(
			'bwdcp_empty_cat',
			array(
				'label'        => esc_html__( 'Show Empty Categories', 'bwdcp-catproduct-td' ),
				'type'         => Controls_Manager::SWITCHER,
				'default'      => '',
				'label_on'     => 'Yes',
				'label_off'    => 'No',
				'return_value' => 'yes',
			)
		);
		$this->add_control(
			'bwdcp_product_include_categories',
			[
				'label'       => esc_html__( 'Include Categories', 'cat-product-grid' ),
				'type'        => \Elementor\Controls_Manager::SELECT2,
				'multiple'    => true,
				'label_block' => true,
				'options'     => $this->bwdcp_get_include_product_categories_options(),
			]
		);
		$this->add_control(
			'bwdcp_product_exclude_categories',
			[
				'label'       => esc_html__( 'Exclude Categories', 'cat-product-grid' ),
				'type'        => \Elementor\Controls_Manager::SELECT2,
				'multiple'    => true,
				'label_block' => true,
				'options'     => $this->bwdcp_get_exclude_product_categories_options(),
			]
		);
		$this->add_control(
			'bwdcp_the_cat_filter',
			[
				'label'             => esc_html__( 'Category Filter', 'bwdcp-catproduct-td' ),
				'type'              => Controls_Manager::SELECT,
				'options'           => [
					'all'        	=> esc_html__( 'All', 'bwdcp-catproduct-td' ),
					'top_label'     => esc_html__( 'Parent', 'bwdcp-catproduct-td' ),
				],
				'default'           => 'all',
			]
		);
		$this->add_control(
			'bwdcp_the_order_by',
			[
				'label'             => esc_html__( 'Order By', 'bwdcp-catproduct-td' ),
				'type'              => Controls_Manager::SELECT,
				'options'           => [
					'name'        	=> esc_html__( 'Name', 'bwdcp-catproduct-td' ),
					'slug'        	=> esc_html__( 'Slug', 'bwdcp-catproduct-td' ),
					'id'          	=> esc_html__( 'ID', 'bwdcp-catproduct-td' ),
					'count'       	=> esc_html__( 'Taxonomy Count', 'bwdcp-catproduct-td' ),
					'description' 	=> esc_html__( 'Description', 'bwdcp-catproduct-td' ),
				],
				'default'           => 'name',
			]
		);
		$this->add_control(
			'bwdcp_blog_order',
			[
				'label' => esc_html__( 'Order', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SELECT,
				'default' => 'DESC',
				'options' => [
					'DESC' => esc_html__( 'Descending', 'bwdcp-catproduct-td' ),
					'ASC' => esc_html__( 'Ascending', 'bwdcp-catproduct-td' ),
				],
			]
		);
		$this->end_controls_section();

		$this->start_controls_section(
			'bwdcp_catproduct_carousel',
			[
				'label' => esc_html__( 'Carousel Settings', 'bwdcp-catproduct-td' ),
				'tab' => Controls_Manager::TAB_CONTENT,
			]
		);
		
		$this->add_control(
			'bwdcp-catproduct-custom-id',
			[
				'label' => esc_html__( 'Custom Id', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::TEXT,
				'default' => esc_html__( 'catproduct-id', 'bwdcp-catproduct-td' ),
			]
		);

		//item-gap
		$this->add_control(
			'bwdcp_slide_margin',
			[
				'label' => esc_html__( 'Item Gap', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::NUMBER,
				'min' => 1,
				'max' => 100,
				'step' => 1,
				'default' => 10,
			]
		);

		//popover-responsive-device
		$this->add_control(
			'bwdcp_popover_responsive_device',
			[
				'label' => esc_html__( 'Responsive Device', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::POPOVER_TOGGLE,
				'label_off' => esc_html__( 'Default', 'bwdcp-catproduct-td' ),
				'label_on' => esc_html__( 'Custom', 'bwdcp-catproduct-td' ),
				'return_value' => 'yes',

			]
		);
		$this->start_popover();

			$this->add_control(
				'bwdcp_slide_desktop_view',
				[
					'label' => esc_html__( 'Desktop View', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::NUMBER,
					'min' => 1,
					'max' => 100,
					'step' => 1,
					'default' => 3,
				]
			);
			$this->add_control(
				'bwdcp_slide_tablet_view',
				[
					'label' => esc_html__( 'Tablet View', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::NUMBER,
					'min' => 1,
					'max' => 100,
					'step' => 1,
					'default' => 2,
				]
			);
			$this->add_control(
				'bwdcp_slide_mobile_view',
				[
					'label' => esc_html__( 'Mobile View', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::NUMBER,
					'min' => 1,
					'max' => 100,
					'step' => 1,
					'default' => 1,
				]
			);

		$this->end_popover();


		//popover-autoplay
		$this->add_control(
			'bwdcp_aupoplay_popover',
			[
				'label' => esc_html__( 'Carousel Controls', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::POPOVER_TOGGLE,
				'label_off' => esc_html__( 'Default', 'bwdcp-catproduct-td' ),
				'label_on' => esc_html__( 'Custom', 'bwdcp-catproduct-td' ),
				'return_value' => 'yes',

			]
		);
		$this->start_popover();

				//infinite_loop_switcher
				$this->add_control(
					'bwdcp_infinite_autoplay_switcher',
					[
						'label' => esc_html__( 'Autoplay', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::SWITCHER,
						'label_on' => esc_html__( 'Show', 'bwdcp-catproduct-td' ),
						'label_off' => esc_html__( 'Hide', 'bwdcp-catproduct-td' ),
						'return_value' => 'yes',
						'default' => 'yes',
					]
				);

				//infinite_loop_switcher
				$this->add_control(
					'bwdcp_infinite_loop_switcher',
					[
						'label' => esc_html__( 'Infinite Loop', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::SWITCHER,
						'label_on' => esc_html__( 'Show', 'bwdcp-catproduct-td' ),
						'label_off' => esc_html__( 'Hide', 'bwdcp-catproduct-td' ),
						'return_value' => 'yes',
						'default' => 'yes',
					]
				);

				//infinite_loop_switcher
				$this->add_control(
					'bwdcp_HoverPause_switcher',
					[
						'label' => esc_html__( 'Hover Pause', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::SWITCHER,
						'label_on' => esc_html__( 'Show', 'bwdcp-catproduct-td' ),
						'label_off' => esc_html__( 'Hide', 'bwdcp-catproduct-td' ),
						'return_value' => 'yes',
						'default' => 'yes',
					]
				);

				//infinite_loop_switcher
				$this->add_control(
					'bwdcp_centermode_switcher',
					[
						'label' => esc_html__( 'Center Mode', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::SWITCHER,
						'label_on' => esc_html__( 'Show', 'bwdcp-catproduct-td' ),
						'label_off' => esc_html__( 'Hide', 'bwdcp-catproduct-td' ),
						'return_value' => 'yes',
						'default' => 'yes',
					]
				);

				$this->add_control(
					'bwdcp_autoplay_timeout',
					[
						'label' => esc_html__( 'Autoplay TimeOut (ms)', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::NUMBER,
						'min' => 1,
						'max' => 100000,
						'step' => 1,
						'default' => 3000,
					]
				);

				$this->add_control(
					'bwdcp_autoplay_speed',
					[
						'label' => esc_html__( 'Autoplay Speeds (ms)', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::NUMBER,
						'min' => 1,
						'max' => 100000,
						'step' => 1,
						'default' => 2000,
					]
				);

				$this->add_control(
					'bwdcp_stace_padding',
					[
						'label' => esc_html__( 'Stage Padding (px)', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::NUMBER,
						'min' => 0,
						'max' => 100000,
						'step' => 1,
						'default' => 0,
					]
				);

		$this->end_popover();


		//popover-//Arrow Navigation
		$this->add_control(
			'bwdcp_arrow_popover',
			[
				'label' => esc_html__( 'Navigation :: Arrow', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::POPOVER_TOGGLE,
				'label_off' => esc_html__( 'Default', 'bwdcp-catproduct-td' ),
				'label_on' => esc_html__( 'Custom', 'bwdcp-catproduct-td' ),
				'return_value' => 'yes',

			]
		);

		$this->start_popover();

			//Arrow Navigation switcher
			$this->add_control(
				'bwdcp_nav_switcher',
				[
					'label' => esc_html__( 'Arrow Navigation ?', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::SWITCHER,
					'label_on' => esc_html__( 'Show', 'bwdcp-catproduct-td' ),
					'label_off' => esc_html__( 'Hide', 'bwdcp-catproduct-td' ),
					'return_value' => 'yes',
					'default' => 'yes',
				]
			);
			//arrow type
			$this->add_control(
				'bwdcp_nav_type',
				[
					'label' => esc_html__( 'Arrow Type', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::SELECT,
					'default' => 'icon',
					'options' => [
						'icon'  => esc_html__( 'Icon', 'bwdcp-catproduct-td' ),
						'text'  => esc_html__( 'Text', 'bwdcp-catproduct-td' ),
					],
					'condition' => [
						'bwdcp_nav_switcher' => 'yes',
					],
				]
			);
			//prev icon
			$this->add_control(
				'bwdcp_nav_prev_arrow',
				[
					'label' => esc_html__( 'Previous Icon', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::ICONS,
					'default' => [
						'value' => 'fas fa-chevron-left',
						'library' => 'fa-solid',
					],
					'condition' => [
						'bwdcp_nav_type' => 'icon',
						'bwdcp_nav_switcher' => 'yes',
					],
				]
			);
			//next icon
			$this->add_control(
				'bwdcp_nav_next_arrow',
				[
					'label' => esc_html__( 'Next Icon', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::ICONS,
					'default' => [
						'value' => 'fas fa-chevron-right',
						'library' => 'fa-solid',
					],
					'condition' => [
						'bwdcp_nav_type' => 'icon',
						'bwdcp_nav_switcher' => 'yes',
					],
				]
			);
			//prev text
			$this->add_control(
				'bwdcp_nav_prev_text',
				[
					'label' => esc_html__( 'Previous Text', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::TEXT,
					'default' => esc_html__( 'Prev', 'bwdcp-catproduct-td' ),
					'dynamic' => [
						'active' => true,
					],
					'condition' => [
						'bwdcp_nav_type' => 'text',
						'bwdcp_nav_switcher' => 'yes',
					],
				]
			);
			//next text
			$this->add_control(
				'bwdcp_nav_next_text',
				[
					'label' => esc_html__( 'Next Text', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::TEXT,
					'default' => esc_html__( 'Next', 'bwdcp-catproduct-td' ),
					'dynamic' => [
						'active' => true,
					],
					'condition' => [
						'bwdcp_nav_type' => 'text',
						'bwdcp_nav_switcher' => 'yes',
					],
				]
			);

		$this->end_popover();



		//popover-//dots
		$this->add_control(
			'bwdcp_dots_popover',
			[
				'label' => esc_html__( 'Navigation :: Dots', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::POPOVER_TOGGLE,
				'label_off' => esc_html__( 'Default', 'bwdcp-catproduct-td' ),
				'label_on' => esc_html__( 'Custom', 'bwdcp-catproduct-td' ),
				'return_value' => 'yes',

			]
		);

		$this->start_popover();

			//dots switcher
			$this->add_control(
				'bwdcp_dots_switcher',
				[
					'label' => esc_html__( 'Active Dots ?', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::SWITCHER,
					'label_on' => esc_html__( 'Show', 'bwdcp-catproduct-td' ),
					'label_off' => esc_html__( 'Hide', 'bwdcp-catproduct-td' ),
					'return_value' => 'yes',
					'default' => 'yes',
				]
			);
			//dots type
			$this->add_control(
				'bwdcp_dots_type',
				[
					'label' => esc_html__( 'Type', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::SELECT,
					'default' => 'dots',
					'options' => [
						'dots'  => esc_html__( 'Dots', 'bwdcp-catproduct-td' ),
						'numbers'  => esc_html__( 'Numbers', 'bwdcp-catproduct-td' ),
					],
					'condition' => [
						'bwdcp_dots_switcher' => 'yes',
					],
				]
			);

			//dots type
			$this->add_control(
				'bwdcp_dots_type_style',
				[
					'label' => esc_html__( 'Dot Style', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::SELECT,
					'default' => '',
					'options' => [
						''  => esc_html__( 'Default', 'bwdcp-catproduct-td' ),
						'bwdcp_dots1'  => esc_html__( 'Style 1', 'bwdcp-catproduct-td' ),
						'bwdcp_dots2'  => esc_html__( 'Style 2', 'bwdcp-catproduct-td' ),
						'bwdcp_dots3'  => esc_html__( 'Style 3', 'bwdcp-catproduct-td' ),
						'bwdcp_dots4'  => esc_html__( 'Style 4', 'bwdcp-catproduct-td' ),
						'bwdcp_dots5'  => esc_html__( 'Style 5', 'bwdcp-catproduct-td' ),
						'bwdcp_dots6'  => esc_html__( 'Style 6', 'bwdcp-catproduct-td' ),
						'bwdcp_dots7'  => esc_html__( 'Style 7', 'bwdcp-catproduct-td' ),
						'bwdcp_dots8'  => esc_html__( 'Style 8', 'bwdcp-catproduct-td' ),
						'bwdcp_dots9'  => esc_html__( 'Style 9', 'bwdcp-catproduct-td' ),
						'bwdcp_dots10'  => esc_html__( 'Style 10', 'bwdcp-catproduct-td' ),
					],
					'condition' => [
						'bwdcp_dots_switcher' => 'yes',
						'bwdcp_dots_type' => 'dots',
					],
				]
			);

		$this->end_popover();
		$this->end_controls_section();

		$this->start_controls_section(
			'bwdcp_content_style',
			[
				'label' => esc_html__( 'Content', 'bwdcp-catproduct-td' ),
				'tab' => Controls_Manager::TAB_STYLE,
				'condition' => [
					'bwdcp_nav_switcher' => 'yes'
				],
			]
		);
		$this->add_responsive_control(
			'bwdcp_content_alignment',
			[
				'label' => esc_html__( 'Content Alignment', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::CHOOSE,
				'options' => [
					'left' => [
						'title' => esc_html__( 'Left', 'bwdcp-catproduct-td' ),
						'icon' => 'eicon-text-align-left',
					],
					'center' => [
						'title' => esc_html__( 'Center', 'bwdcp-catproduct-td' ),
						'icon' => 'eicon-text-align-center',
					],
					'right' => [
						'title' => esc_html__( 'Right', 'bwdcp-catproduct-td' ),
						'icon' => 'eicon-text-align-right',
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdcp_extra-content, {{WRAPPER}} .bwdcp_catacory-content' => 'text-align: {{VALUE}}; align-items: {{VALUE}};',
				],
				'toggle' => true,
			]
		);
		$this->add_control(
			'bwdcp_box_content_bg_color',
			[
				'label' => esc_html__( 'Content BG', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp_catacory-content' => 'background: {{VALUE}}',
				],
			]
		);
		$this->add_responsive_control(
            'bwdcp_content_border_radius',
            [
                'label' => esc_html__('Border Radius', 'bwdcp-catproduct-td'),
                'type' => Controls_Manager::DIMENSIONS,
                'size_units' => ['px', 'em', 'rem', '%'],
                'selectors' => [
                    '{{WRAPPER}} .bwdcp_catacory-content' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}} !important;',
                ],
            ]
        );
		$this->add_responsive_control(
            'bwdcp_content_padding',
            [
                'label' => esc_html__('Content Padding', 'bwdcp-catproduct-td'),
                'type' => Controls_Manager::DIMENSIONS,
                'size_units' => ['px', 'em', 'rem', '%'],
                'selectors' => [
                    '{{WRAPPER}} .bwdcp_catacory-content' => 'padding-block: {{TOP}}{{UNIT}} {{BOTTOM}}{{UNIT}}; padding-inline: {{LEFT}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
            ]
        );
		$this->end_controls_section();

		$this->start_controls_section(
			'bwdcp_catproduct_image_style',
			[
				'label' => esc_html__( 'Image', 'bwdcp-catproduct-td' ),
				'tab' => Controls_Manager::TAB_STYLE,
				'condition' => [
					'bwdcp_image' => 'yes'
				],
			]
		);
		$this->add_responsive_control(
			'bwdcp_the_post_image_width_size',
			[
				'label' => esc_html__( 'Thumbnail Size', 'creative-products' ),
				'type' => Controls_Manager::SLIDER,
				'range' => [
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdcp_catagory-img img' => 'block-size: {{SIZE}}% !important; inline-size: {{SIZE}}% !important;',
				],
			]
		);
		$this->add_control(
			'bwdcp_button_image_overly_color',
			[
				'label' => esc_html__( 'Image Overlay', 'creative-products' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp_catagory-img a:before, {{WRAPPER}} .bwdcp_catagory_image_overlay' => 'background: {{VALUE}}',
				],
			]
		);
		$this->add_responsive_control(
            'bwdcp_image_border_radius',
            [
                'label' => esc_html__('Image Radius', 'creative-products'),
                'type' => Controls_Manager::DIMENSIONS,
                'size_units' => ['px', 'em', 'rem', '%'],
                'selectors' => [
                    '{{WRAPPER}} .bwdcp_catagory-img img' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                ],
            ]
        );
		$this->end_controls_section();

		$this->start_controls_section(
			'bwdcp_catproduct_title_style',
			[
				'label' => esc_html__( 'Title', 'bwdcp-catproduct-td' ),
				'tab' => Controls_Manager::TAB_STYLE,
				'condition' => [
					'bwdcp_title' => 'yes'
				],
			]
		);
		// Hover control start for title
		$this->start_controls_tabs(
			'bwdcp_title_style_post'
		);
		$this->start_controls_tab(
			'bwdcp_title_normal_post',
			[
				'label' => esc_html__( 'Normal', 'bwdcp-catproduct-td' ),
				'condition' => [
					'bwdcp_title' => 'yes',
				],
			]
		);
		// Normal Controls
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'bwdcp_title_typography',
				'selector' => '{{WRAPPER}} .bwdcp_catagory-title',
				'condition' => [
					'bwdcp_title' => 'yes',
				],
			]
		);
		$this->add_control(
			'bwdcp_title_color',
			[
				'label' => esc_html__( 'Color', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp_catagory-title' => 'color: {{VALUE}} !important',
				],
				'condition' => [
					'bwdcp_title' => 'yes',
				],
			]
		);
		$this->add_control(
			'bwdcp_title_bg_color',
			[
				'label' => esc_html__( 'Background', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp_catagory-title' => 'background: {{VALUE}}',
				],
				'condition' => [
					'bwdcp_title' => 'yes',
				],
			]
		);
		$this->end_controls_tab();
		$this->start_controls_tab(
			'bwdcp_title_hover_tab',
			[
				'label' => esc_html__( 'Hover', 'bwdcp-catproduct-td' ),
				'condition' => [
					'bwdcp_title' => 'yes',
				],
			]
		);
		// Hover Controls
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'bwdcp_title_hover_typography',
				'selector' => '{{WRAPPER}} .bwdcp_catagory-title:hover',
				'condition' => [
					'bwdcp_title' => 'yes',
				],
			]
		);
		$this->add_control(
			'bwdcp_title_hover_color',
			[
				'label' => esc_html__( 'Hover Color', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp_catagory-title:hover' => 'color: {{VALUE}}',
				],
				'condition' => [
					'bwdcp_title' => 'yes',
				],
			]
		);
		$this->add_control(
			'bwdcp_title_hover_bg_color',
			[
				'label' => esc_html__( 'Background', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp_catagory-title:hover' => 'background: {{VALUE}}',
				],
				'condition' => [
					'bwdcp_title' => 'yes',
				],
			]
		);
		$this->end_controls_tab();
		$this->end_controls_tabs();
		// Hover Control End
		$this->add_responsive_control(
            'bwdcp_titlee_border_radius',
            [
                'label' => esc_html__('Border Radius', 'bwdcp-catproduct-td'),
                'type' => Controls_Manager::DIMENSIONS,
				'separator' => 'before',
                'size_units' => ['px', 'em', 'rem', '%'],
                'selectors' => [
                    '{{WRAPPER}} .bwdcp_catagory-title' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}} !important;',
                ],
            ]
        );
		$this->add_responsive_control(
            'bwdcp_title_padding',
            [
                'label' => esc_html__('Padding', 'bwdcp-catproduct-td'),
                'type' => Controls_Manager::DIMENSIONS,
				'separator' => 'before',
                'size_units' => ['px', 'em', 'rem', '%'],
                'selectors' => [
                    '{{WRAPPER}} .bwdcp_catagory-title' => 'padding-block: {{TOP}}{{UNIT}} {{BOTTOM}}{{UNIT}}; padding-inline: {{LEFT}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
				'condition' => [
					'bwdcp_title' => 'yes',
				],
            ]
        );
		$this->add_responsive_control(
            'bwdcp_title_margin',
            [
                'label' => esc_html__('Margin', 'bwdcp-catproduct-td'),
                'type' => Controls_Manager::DIMENSIONS,
                'size_units' => ['px', 'em', 'rem', '%'],
                'selectors' => [
                    '{{WRAPPER}} .bwdcp_catagory-title' => 'margin-block: {{TOP}}{{UNIT}} {{BOTTOM}}{{UNIT}}; margin-inline: {{LEFT}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
				'condition' => [
					'bwdcp_title' => 'yes',
				],
            ]
        );
		$this->end_controls_section();

		$this->start_controls_section(
			'bwdcp_catproduct_review_style',
			[
				'label' => esc_html__( 'Review', 'bwdcp-catproduct-td' ),
				'tab' => Controls_Manager::TAB_STYLE,
				'condition' => [
					'bwdcp_review' => 'yes'
				],
			]
		);
		// Hover control start for taxonomy comment
		$this->start_controls_tabs(
			'bwdcp_taxonomy_comment_style_post'
		);
		$this->start_controls_tab(
			'bwdcp_taxonomy_comment_normal_post',
			[
				'label' => esc_html__( 'Star', 'bwdcp-catproduct-td' ),
			]
		);
		// Normal Controls
		$this->add_responsive_control(
			'bwdcp_review_icon_size',
			[
				'label' => esc_html__( 'Icon Size', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SLIDER,
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 500,
						'step' => 1,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdcp-star-rating .bwdcp-star-icons' => 'font-size: {{SIZE}}{{UNIT}};',
				],
			]
		);
		$this->add_control(
			'bwdcp_taxonomy_comment_color',
			[
				'label' => esc_html__( 'Color', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp-star-rating .bwdcp-star-icons' => 'color: {{VALUE}}',
				],
			]
		);
		$this->end_controls_tab();
		$this->start_controls_tab(
			'bwdcp_taxonomy_comment_hover_tab',
			[
				'label' => esc_html__( 'Hover', 'bwdcp-catproduct-td' ),
			]
		);
		// Hover Controls
		$this->add_responsive_control(
			'bwdcp_review_icon_hover_size',
			[
				'label' => esc_html__( 'Icon Size', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SLIDER,
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 500,
						'step' => 1,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdcp-star-rating:hover .bwdcp-star-icons' => 'font-size: {{SIZE}}{{UNIT}};',
				],
			]
		);
		$this->add_control(
			'bwdcp_taxonomy_comment_hover_color',
			[
				'label' => esc_html__( 'Color', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp-star-rating:hover .bwdcp-star-icons' => 'color: {{VALUE}}',
				],
			]
		);
		$this->end_controls_tab();
		$this->end_controls_tabs();
		// Hover Control End
		$this->end_controls_section();

		$this->start_controls_section(
			'bwdcp_catproduct_description_style',
			[
				'label' => esc_html__( 'Description', 'bwdcp-catproduct-td' ),
				'tab' => Controls_Manager::TAB_STYLE,
				'condition' => [
					'bwdcp_description' => 'yes'
				],
			]
		);
		// Hover control start for description
		$this->start_controls_tabs(
			'bwdcp_description_style_post'
		);
		$this->start_controls_tab(
			'bwdcp_description_normal_post',
			[
				'label' => esc_html__( 'Normal', 'bwdcp-catproduct-td' ),
				'condition' => [
					'bwdcp_description' => 'yes',
				],
			]
		);
		// Normal Controls
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'bwdcp_description_typography',
				'selector' => '{{WRAPPER}} .bwdcp_catagory-disce',
				'condition' => [
					'bwdcp_description' => 'yes',
				],
			]
		);
		$this->add_control(
			'bwdcp_description_color',
			[
				'label' => esc_html__( 'Color', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp_catagory-disce' => 'color: {{VALUE}}',
				],
				'condition' => [
					'bwdcp_description' => 'yes',
				],
			]
		);
		$this->add_control(
			'bwdcp_description_bg_color',
			[
				'label' => esc_html__( 'Background', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp_catagory-disce' => 'background: {{VALUE}}',
				],
				'condition' => [
					'bwdcp_description' => 'yes',
				],
			]
		);
		$this->end_controls_tab();
		$this->start_controls_tab(
			'bwdcp_description_hover_tab',
			[
				'label' => esc_html__( 'Hover', 'bwdcp-catproduct-td' ),
				'condition' => [
					'bwdcp_description' => 'yes',
				],
			]
		);
		// Hover Controls
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'bwdcp_description_hover_typography',
				'selector' => '{{WRAPPER}} .bwdcp_catagory-disce:hover',
				'condition' => [
					'bwdcp_description' => 'yes',
				],
			]
		);
		$this->add_control(
			'bwdcp_description_hover_color',
			[
				'label' => esc_html__( 'Hover Color', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp_catagory-disce:hover' => 'color: {{VALUE}}',
				],
				'condition' => [
					'bwdcp_description' => 'yes',
				],
			]
		);
		$this->add_control(
			'bwdcp_description_hover_bg_color',
			[
				'label' => esc_html__( 'Background', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp_catagory-disce:hover' => 'background: {{VALUE}}',
				],
				'condition' => [
					'bwdcp_description' => 'yes',
				],
			]
		);
		$this->end_controls_tab();
		$this->end_controls_tabs();
		// Hover Control End
		$this->add_responsive_control(
            'bwdcp_desc_border_radius',
            [
                'label' => esc_html__('Border Radius', 'bwdcp-catproduct-td'),
                'type' => Controls_Manager::DIMENSIONS,
				'separator' => 'before',
                'size_units' => ['px', 'em', 'rem', '%'],
                'selectors' => [
                    '{{WRAPPER}} .bwdcp_catagory-disce' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}} !important;',
                ],
            ]
        );
		$this->add_responsive_control(
            'bwdcp_desc_padding',
            [
                'label' => esc_html__('Padding', 'bwdcp-catproduct-td'),
                'type' => Controls_Manager::DIMENSIONS,
				'separator' => 'before',
                'size_units' => ['px', 'em', 'rem', '%'],
                'selectors' => [
                    '{{WRAPPER}} .bwdcp_catagory-disce' => 'padding-block: {{TOP}}{{UNIT}} {{BOTTOM}}{{UNIT}}; padding-inline: {{LEFT}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
				'condition' => [
					'bwdcp_description' => 'yes',
				],
            ]
        );
		$this->add_responsive_control(
            'bwdcp_desc_margin',
            [
                'label' => esc_html__('Margin', 'bwdcp-catproduct-td'),
                'type' => Controls_Manager::DIMENSIONS,
                'size_units' => ['px', 'em', 'rem', '%'],
                'selectors' => [
                    '{{WRAPPER}} .bwdcp_catagory-disce' => 'margin-block: {{TOP}}{{UNIT}} {{BOTTOM}}{{UNIT}}; margin-inline: {{LEFT}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
				'condition' => [
					'bwdcp_description' => 'yes',
				],
            ]
        );
		$this->end_controls_section();

		$this->start_controls_section(
			'bwdcp_catproduct_button_style',
			[
				'label' => esc_html__( 'Button', 'bwdcp-catproduct-td' ),
				'tab' => Controls_Manager::TAB_STYLE,
				'condition' => [
					'bwdcp_button' => 'yes'
				],
			]
		);
		// Hover control start for description
		$this->start_controls_tabs(
			'bwdcp_button_style_post'
		);
		$this->start_controls_tab(
			'bwdcp_button_normal_post',
			[
				'label' => esc_html__( 'Normal', 'bwdcp-catproduct-td' ),
			]
		);
		// Normal Controls
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'bwdcp_button_typography',
				'selector' => '{{WRAPPER}} .bwdcp_catagory-bttn .bwdcp_Cbutton',
			]
		);
		$this->add_control(
			'bwdcp_button_color',
			[
				'label' => esc_html__( 'Color', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp_catagory-bttn .bwdcp_Cbutton' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_control(
			'bwdcp_button_bg_color',
			[
				'label' => esc_html__( 'Background', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp_catagory-bttn .bwdcp_Cbutton' => 'background: {{VALUE}}',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdcp_button_border',
				'label' => esc_html__( 'Border', 'bwdcp-catproduct-td' ),
				'selector' => '{{WRAPPER}} .bwdcp_catagory-bttn .bwdcp_Cbutton',
			]
		);
		$this->end_controls_tab();
		$this->start_controls_tab(
			'bwdcp_button_hover_tab',
			[
				'label' => esc_html__( 'Hover', 'bwdcp-catproduct-td' ),
			]
		);
		// Hover Controls
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'bwdcp_button_hover_typography',
				'selector' => '{{WRAPPER}} .bwdcp_catagory-bttn .bwdcp_Cbutton:hover',
			]
		);
		$this->add_control(
			'bwdcp_button_hover_color',
			[
				'label' => esc_html__( 'Hover Color', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp_catagory-bttn .bwdcp_Cbutton:hover' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_control(
			'bwdcp_button_bg_hover_color',
			[
				'label' => esc_html__( 'Background', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp_catagory-bttn .bwdcp_Cbutton:hover' => 'background: {{VALUE}}',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdcp_button_border_hover',
				'label' => esc_html__( 'Border', 'bwdcp-catproduct-td' ),
				'selector' => '{{WRAPPER}} .bwdcp_catagory-bttn .bwdcp_Cbutton:hover',
			]
		);
		$this->end_controls_tab();
		$this->end_controls_tabs();
		// Hover Control End

		$this->add_responsive_control(
            'bwdcp_button_bg_border_radius',
            [
                'label' => esc_html__('Border Radius', 'bwdcp-catproduct-td'),
                'type' => Controls_Manager::DIMENSIONS,
				'separator' => 'before',
                'size_units' => ['px', 'em', 'rem', '%'],
                'selectors' => [
                    '{{WRAPPER}} .bwdcp_catagory-bttn .bwdcp_Cbutton' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}} !important;',
                ],
            ]
        );
		$this->add_responsive_control(
            'bwdcp_button_icon_padding',
            [
                'label' => esc_html__('Padding', 'bwdcp-catproduct-td'),
                'type' => Controls_Manager::DIMENSIONS,
                'size_units' => ['px', 'em', 'rem', '%'],
                'selectors' => [
                    '{{WRAPPER}} .bwdcp_catagory-bttn .bwdcp_Cbutton' => 'padding-block: {{TOP}}{{UNIT}} {{BOTTOM}}{{UNIT}}; padding-inline: {{LEFT}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
            ]
        );
		$this->end_controls_section();

		$this->start_controls_section(
			'bwdcp_catproduct_carousel_box_style',
			[
				'label' => esc_html__( 'Box Style', 'bwdcp-catproduct-td' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);
		// Hover control start for box
		$this->start_controls_tabs(
			'bwdcp_box_style_post'
		);
		$this->start_controls_tab(
			'bwdcp_box_normal_post',
			[
				'label' => esc_html__( 'Normal', 'bwdcp-catproduct-td' ),
			]
		);
		// Normal Controls
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'bwdcp_box_bg_grediant_color',
				'label' => esc_html__( 'Background', 'bwdcp-catproduct-td' ),
				'types' => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .bwdcp_catagory_6 .bwdcp_cat_n_bg:before, {{WRAPPER}} .bwdcp_cat_box_common, {{WRAPPER}} .bwdcp_box_bg',
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'bwdcp_box_boxshadow',
				'label' => esc_html__( 'Box Shadow', 'bwdcp-catproduct-td' ),
				'selector' => '{{WRAPPER}} .bwdcp_cat_box_common, {{WRAPPER}} .bwdcp_box_shadow',
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdcp_box_border',
				'label' => esc_html__( 'Border', 'bwdcp-catproduct-td' ),
				'selector' => '{{WRAPPER}} .bwdcp_cat_box_common, {{WRAPPER}} .bwdcp_border_type',
			]
		);
		$this->end_controls_tab();
		$this->start_controls_tab(
			'bwdcp_box_hover_tab',
			[
				'label' => esc_html__( 'Hover', 'bwdcp-catproduct-td' ),
			]
		);
		// Hover Controls
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'bwdcp_box_bg_grediant_color_hover',
				'label' => esc_html__( 'Background', 'bwdcp-catproduct-td' ),
				'types' => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .bwdcp_catagory_7 .bwdcp_cat_h_bg:before, {{WRAPPER}} .bwdcp_cat_box_common:hover, {{WRAPPER}} .bwdcp_box_bg:hover, {{WRAPPER}} .bwdcp_box_hover_bg:hover',
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'bwdcp_box_boxshadow_hover',
				'label' => esc_html__( 'Box Shadow', 'bwdcp-catproduct-td' ),
				'selector' => '{{WRAPPER}} .bwdcp_cat_box_common:hover',
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdcp_box_border_hover',
				'label' => esc_html__( 'Border', 'bwdcp-catproduct-td' ),
				'selector' => '{{WRAPPER}} .bwdcp_cat_box_common:hover',
			]
		);
		$this->end_controls_tab();
		$this->end_controls_tabs();
		// Hover Control End

		$this->add_responsive_control(
            'bwdcp_the_box_border_radius',
            [
                'label' => esc_html__('Border Radius', 'bwdcp-catproduct-td'),
                'type' => Controls_Manager::DIMENSIONS,
				'separator' => 'before',
                'size_units' => ['px', 'em', 'rem', '%'],
                'selectors' => [
                    '{{WRAPPER}} .bwdcp_cat_box_common' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                ],
            ]
        );
		$this->add_responsive_control(
            'bwdcp_the_box_border_bottom',
            [
                'label' => esc_html__('Margin', 'bwdcp-catproduct-td'),
                'type' => Controls_Manager::DIMENSIONS,
                'size_units' => ['px', 'rem', '%'],
                'selectors' => [
                    '{{WRAPPER}} .bwdcp_cat_box_common' => 'margin-block: {{TOP}}{{UNIT}} {{BOTTOM}}{{UNIT}}; margin-inline: {{LEFT}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
            ]
        );
		$this->add_responsive_control(
            'bwdcp_box_padding',
            [
                'label' => esc_html__('Box Padding', 'bwdcp-catproduct-td'),
                'type' => Controls_Manager::DIMENSIONS,
                'size_units' => ['px', 'rem', '%'],
                'selectors' => [
                    '{{WRAPPER}} .bwdcp_cat_box_common' => 'padding-block: {{TOP}}{{UNIT}} {{BOTTOM}}{{UNIT}}; padding-inline: {{LEFT}}{{UNIT}} {{RIGHT}}{{UNIT}};',
                ],
            ]
        );
		$this->end_controls_section();

		$this->start_controls_section(
			'bwdcp_catproduct_carousel_arrow_style',
			[
				'label' => esc_html__( 'Navigation :: Arrow', 'bwdcp-catproduct-td' ),
				'tab' => Controls_Manager::TAB_STYLE,
				'condition' => [
					'bwdcp_nav_switcher' => 'yes'
				],
			]
		);

		//norlam-hover-tab
		$this->start_controls_tabs(
			'style_tabs',
			[
				'separator' => 'before',
			]
		);

		//highlight-normal-style------------------------------------------
		$this->start_controls_tab(
			'style_normal_tab',
			[
				'label' => esc_html__( 'Normal', 'bwdcp-catproduct-td' ),
			]
		);

			//arrow-color
			$this->add_control(
				'bwdcp_arrow_color',
				[
					'label' => esc_html__( 'Color', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next ' => 'color: {{VALUE}}',
					],
				]
			);

			//arrow-background
			$this->add_group_control(
				\Elementor\Group_Control_Background::get_type(),
				[
					'name' => 'bwdcp_arrow_background_color',
					'label' => esc_html__( 'Background', 'bwdcp-catproduct-td' ),
					'types' => [ 'classic', 'gradient'],
					'selector' => '{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next ',
				]
			);

			//size
			$this->add_responsive_control(
				'bwdcp_arrow_size',
				[
					'label' => esc_html__( 'Size', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 1,
						],
						'%' => [
							'min' => 0,
							'max' => 1000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next' => 'font-size: {{SIZE}}{{UNIT}};',
					],
					'condition' => [
						'bwdcp_nav_type' => 'icon',
					],
				]
			);

			//typography
			$this->add_group_control(
				\Elementor\Group_Control_Typography::get_type(),
				[
					'name' => 'bwdcp_arrow_tetx_typography',
					'selector' => '{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev span, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next span',
					'condition' => [
						'bwdcp_nav_type' => 'text',
					],
				]
			);

			//width
			$this->add_responsive_control(
				'bwdcp_arrow_width',
				[
					'label' => esc_html__( 'Width', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 1,
						],
						'%' => [
							'min' => 0,
							'max' => 1000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next ' => 'inline-size: {{SIZE}}{{UNIT}};',
					],
				]
			);

			//height
			$this->add_responsive_control(
				'bwdcp_arrow_height',
				[
					'label' => esc_html__( 'Height', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 1,
						],
						'%' => [
							'min' => 0,
							'max' => 1000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next ' => 'block-size: {{SIZE}}{{UNIT}};',
					],
				]
			);

			//border
			$this->add_group_control(
				\Elementor\Group_Control_Border::get_type(),
				[
					'name' => 'bwdcp_arrow_border',
					'label' => esc_html__( 'Border', 'bwdcp-catproduct-td' ),
					'selector' => '{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next ',
				]
			);

			//Border Radius
			$this->add_responsive_control(
				'bwdcp_arrow_border-radius',
				[
					'label' => esc_html__( 'Border Radius', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next ' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//Box Shadow
			$this->add_group_control(
				\Elementor\Group_Control_Box_Shadow::get_type(),
				[
					'name' => 'bwdcp_arrow_box-shadow',
					'label' => esc_html__( 'Box Shadow', 'bwdcp-catproduct-td' ),
					'selector' => '{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next ',
				]
			);

			//opacity
			$this->add_control(
				'bwdcp_arrow_opacity',
				[
					'label'       => esc_html__('Arrow Opacity', 'bwdcp-catproduct-td'),
					'type'        => Controls_Manager::NUMBER,
					'min'         => 0,
					'max'         => 100,
					'step'        => .1,
					'selectors'   => [
						'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next ' => 'opacity: {{SIZE}}',
					],
				]
			);

			//visibility
			$this->add_responsive_control(
				'bwdcp_photostack_visibility',
				[
					'label'     => esc_html__('Visibility', 'bwdcp-catproduct-td'),
					'type'      => Controls_Manager::SELECT,
					'options'   => [
						'visible' => esc_html__('Visible', 'bwdcp-catproduct-td'),
						'hidden'  => esc_html__('Hidden', 'bwdcp-catproduct-td'),
					],
					'default'   => 'visible',
					'selectors' => [
						'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next ' => 'visibility: {{VALUE}}',
					],
				]
			);

			//popover-//Arrow Navigation
			$this->add_control(
				'bwdcp_arrow_popover_style',
				[
					'label' => esc_html__( 'Position', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::POPOVER_TOGGLE,
					'label_off' => esc_html__( 'Default', 'bwdcp-catproduct-td' ),
					'label_on' => esc_html__( 'Custom', 'bwdcp-catproduct-td' ),
					'return_value' => 'yes',

				]
			);

			$this->start_popover();

				//left-arrow
				$this->add_control(
					'bwdcp_arrow_left_heading',
					[
						'label' => esc_html__( 'Left Arrow', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::HEADING,
						'separator' => 'before',
					]
				);

				//top
				$this->add_responsive_control(
					'bwdcp_arrow_left_position_vertical',
					[
						'label' => esc_html__( 'Vertical', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev ' => 'inset-block-start: {{SIZE}}{{UNIT}};',
						],
					]
				);

				//left
				$this->add_responsive_control(
					'bwdcp_arrow_left_position_horizontal',
					[
						'label' => esc_html__( 'Horizontal', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev ' => 'inset-inline-start: {{SIZE}}{{UNIT}};',
						],
					]
				);


				//right-arrow
				$this->add_control(
					'bwdcp_arrow_right_heading',
					[
						'label' => esc_html__( 'Right Arrow', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::HEADING,
						'separator' => 'before',
					]
				);

				//top
				$this->add_responsive_control(
					'bwdcp_arrow_Right_position_vertical',
					[
						'label' => esc_html__( 'Vertical', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next ' => 'inset-block-start: {{SIZE}}{{UNIT}};',
						],
					]
				);

				//right
				$this->add_responsive_control(
					'bwdcp_arrow_right_position_horizontal',
					[
						'label' => esc_html__( 'Horizontal', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next ' => 'inset-inline-end: {{SIZE}}{{UNIT}};',
						],
					]
				);

			$this->end_popover();

		$this->end_controls_tab();



		//highlight-hover-style------------------------------------------
		$this->start_controls_tab(
			'style_hover_tab',
			[
				'label' => esc_html__( 'Hover', 'bwdcp-catproduct-td' ),
			]
		);

			//arrow-color
			$this->add_control(
				'bwdcp_arrow_color_hover',
				[
					'label' => esc_html__( 'Color', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev:hover, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next:hover' => 'color: {{VALUE}}',
					],
				]
			);

			//arrow-background
			$this->add_group_control(
				\Elementor\Group_Control_Background::get_type(),
				[
					'name' => 'bwdcp_arrow_background_color_hover',
					'label' => esc_html__( 'Background', 'bwdcp-catproduct-td' ),
					'types' => [ 'classic', 'gradient'],
					'selector' => '{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev:hover, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next:hover',
				]
			);

			//size
			$this->add_responsive_control(
				'bwdcp_arrow_size_hover',
				[
					'label' => esc_html__( 'Size', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 1,
						],
						'%' => [
							'min' => 0,
							'max' => 1000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev:hover, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next:hover' => 'font-size: {{SIZE}}{{UNIT}};',
					],
				]
			);

			//typography
			$this->add_group_control(
				\Elementor\Group_Control_Typography::get_type(),
				[
					'name' => 'bwdcp_arrow_tetx_typography_hover',
					'selector' => '{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev:hover span, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next:hover span',
					'condition' => [
						'bwdcp_nav_type' => 'text',
					],
				]
			);

			//width
			$this->add_responsive_control(
				'bwdcp_arrow_width_hover',
				[
					'label' => esc_html__( 'Width', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 1,
						],
						'%' => [
							'min' => 0,
							'max' => 1000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev:hover, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next:hover ' => 'inline-size: {{SIZE}}{{UNIT}};',
					],
				]
			);
			//height
			$this->add_responsive_control(
				'bwdcp_arrow_height_hover',
				[
					'label' => esc_html__( 'Height', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 1,
						],
						'%' => [
							'min' => 0,
							'max' => 1000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev:hover, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next:hover ' => 'block-size: {{SIZE}}{{UNIT}};',
					],
				]
			);

			//border
			$this->add_group_control(
				\Elementor\Group_Control_Border::get_type(),
				[
					'name' => 'bwdcp_arrow_border_hover',
					'label' => esc_html__( 'Border', 'bwdcp-catproduct-td' ),
					'selector' => '{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev:hover, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next:hover',
				]
			);

			//Border Radius
			$this->add_responsive_control(
				'bwdcp_arrow_border-radius_hover',
				[
					'label' => esc_html__( 'Border Radius', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev:hover, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next:hover' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//Box Shadow
			$this->add_group_control(
				\Elementor\Group_Control_Box_Shadow::get_type(),
				[
					'name' => 'bwdcp_arrow_box-shadow_hover',
					'label' => esc_html__( 'Box Shadow', 'bwdcp-catproduct-td' ),
					'selector' => '{{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-prev:hover, {{WRAPPER}} .bwdcp-owl-nav button.bwdcp-owl-next:hover',
				]
			);

			//opacity
			$this->add_control(
				'bwdcp_arrow_opacity_hover',
				[
					'label'       => esc_html__('Arrow Opacity', 'bwdcp-catproduct-td'),
					'type'        => Controls_Manager::NUMBER,
					'min'         => 0,
					'max'         => 100,
					'step'        => .1,
					'selectors'   => [
						'{{WRAPPER}} .bwdcp-owl.bwdcp-owl-carousel:hover .bwdcp-owl-nav button.bwdcp-owl-prev, {{WRAPPER}} .bwdcp-owl.bwdcp-owl-carousel:hover .bwdcp-owl-nav button.bwdcp-owl-next ' => 'opacity: {{SIZE}}',
					],
				]
			);

			//visibility
			$this->add_responsive_control(
				'bwdcp_photostack_visibility_hover',
				[
					'label'     => esc_html__('Visibility', 'bwdcp-catproduct-td'),
					'type'      => Controls_Manager::SELECT,
					'options'   => [
						'visible' => esc_html__('Visible', 'bwdcp-catproduct-td'),
						'hidden'  => esc_html__('Hidden', 'bwdcp-catproduct-td'),
					],
					'default'   => 'visible',
					'selectors' => [
						'{{WRAPPER}} .bwdcp-owl.bwdcp-owl-carousel:hover .bwdcp-owl-nav button.bwdcp-owl-prev, {{WRAPPER}} .bwdcp-owl.bwdcp-owl-carousel:hover .bwdcp-owl-nav button.bwdcp-owl-next ' => 'visibility: {{VALUE}}',
					],
				]
			);

			//popover-//Arrow Navigation
			$this->add_control(
				'bwdcp_arrow_popover_style_hover',
				[
					'label' => esc_html__( 'Position', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::POPOVER_TOGGLE,
					'label_off' => esc_html__( 'Default', 'bwdcp-catproduct-td' ),
					'label_on' => esc_html__( 'Custom', 'bwdcp-catproduct-td' ),
					'return_value' => 'yes',

				]
			);

			$this->start_popover();

				//left-arrow-heading
				$this->add_control(
					'bwdcp_arrow_left_heading_hover',
					[
						'label' => esc_html__( 'Left Arrow', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::HEADING,
						'separator' => 'before',
					]
				);

				//top
				$this->add_responsive_control(
					'bwdcp_arrow_left_position_vertical_hover',
					[
						'label' => esc_html__( 'Vertical', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdcp-owl.bwdcp-owl-carousel:hover .bwdcp-owl-nav button.bwdcp-owl-prev ' => 'inset-block-start: {{SIZE}}{{UNIT}};',
						],
					]
				);

				//left
				$this->add_responsive_control(
					'bwdcp_arrow_left_position_horizontal_hover',
					[
						'label' => esc_html__( 'Horizontal', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdcp-owl.bwdcp-owl-carousel:hover .bwdcp-owl-nav button.bwdcp-owl-prev ' => 'inset-inline-start: {{SIZE}}{{UNIT}};',
						],
					]
				);


				//right-arrow-heading
				$this->add_control(
					'bwdcp_arrow_right_heading_hover',
					[
						'label' => esc_html__( 'Right Arrow', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::HEADING,
						'separator' => 'before',
					]
				);

				//top
				$this->add_responsive_control(
					'bwdcp_arrow_Right_position_vertical_hover',
					[
						'label' => esc_html__( 'Vertical', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdcp-owl.bwdcp-owl-carousel:hover .bwdcp-owl-nav button.bwdcp-owl-next ' => 'inset-block-start: {{SIZE}}{{UNIT}};',
						],
					]
				);

				//right
				$this->add_responsive_control(
					'bwdcp_arrow_right_position_horizontal_hover',
					[
						'label' => esc_html__( 'Horizontal', 'bwdcp-catproduct-td' ),
						'type' => Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdcp-owl.bwdcp-owl-carousel:hover .bwdcp-owl-nav button.bwdcp-owl-next ' => 'inset-inline-end: {{SIZE}}{{UNIT}};',
						],
					]
				);

			$this->end_popover();

		$this->end_controls_tab();
		$this->end_controls_tabs();



		$this->end_controls_section();




		$this->start_controls_section(
			'bwdcp_catproduct_carousel_dots_style',
			[
				'label' => esc_html__( 'Navigation :: Dots', 'bwdcp-catproduct-td' ),
				'tab' => Controls_Manager::TAB_STYLE,
				'condition' => [
					'bwdcp_dots_switcher' => 'yes'
				],
			]
		);

		//popover-//dots Navigation
		$this->add_control(
			'bwdcp_dots_popover_style',
			[
				'label' => esc_html__( 'Position', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::POPOVER_TOGGLE,
				'label_off' => esc_html__( 'Default', 'bwdcp-catproduct-td' ),
				'label_on' => esc_html__( 'Custom', 'bwdcp-catproduct-td' ),
				'return_value' => 'yes',

			]
		);

		$this->start_popover();

			//top
			$this->add_responsive_control(
				'bwdcp_dots_Right_position_vertical',
				[
					'label' => esc_html__( 'Vertical', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => -1000,
							'max' => 1000,
							'step' => 1,
						],
						'%' => [
							'min' => -1000,
							'max' => 1000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdcp-owl-dots' => 'inset-block-start: {{SIZE}}{{UNIT}};',
					],
				]
			);

			//left
			$this->add_responsive_control(
				'bwdcp_dots_left_position_horizontal',
				[
					'label' => esc_html__( 'Horizontal', 'bwdcp-catproduct-td' ),
					'type' => Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => -1000,
							'max' => 1000,
							'step' => 1,
						],
						'%' => [
							'min' => -1000,
							'max' => 1000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdcp-owl-dots' => 'inset-inline-start: {{SIZE}}{{UNIT}};',
					],
				]
			);

		$this->end_popover();

		//dots-gap
		$this->add_responsive_control(
			'bwdcp_dots_gap_ertical',
			[
				'label' => esc_html__( 'Vertical Gap', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdcp-owl-dots' => 'margin-block-start: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//dots-gap
		$this->add_responsive_control(
			'bwdcp_dots_gap',
			[
				'label' => esc_html__( 'Dots Gap', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot:not(:last-child) ' => 'margin-inline-end: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//alignment
		$this->add_responsive_control(
			'bwdcp_dots_alignment',
			[
				'label' => esc_html__( 'Alignment', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::CHOOSE,
				'options' => [
					'left' => [
						'title' => esc_html__( 'Left', 'bwdcp-catproduct-td' ),
						'icon' => 'eicon-text-align-left',
					],
					'center' => [
						'title' => esc_html__( 'Center', 'bwdcp-catproduct-td' ),
						'icon' => 'eicon-text-align-center',
					],
					'right' => [
						'title' => esc_html__( 'Right', 'bwdcp-catproduct-td' ),
						'icon' => 'eicon-text-align-right',
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdcp-owl-dots' => 'text-align: {{VALUE}}',
				],
				'toggle' => true,
				'default' => 'center',
			]
		);

		//norlam-hover-tab
		$this->start_controls_tabs(
			'style_tabs_dots',
			[
				'separator' => 'before',
			]
		);

		//highlight-normal-style------------------------------------------
		$this->start_controls_tab(
			'style_normal_tab_dots',
			[
				'label' => esc_html__( 'Normal', 'bwdcp-catproduct-td' ),
			]
		);

		//dots-color
		$this->add_control(
			'bwdcp_dots_number_color',
			[
				'label' => esc_html__( 'Color', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot span' => 'color: {{VALUE}}',
				],
				'condition' => [
					'bwdcp_dots_type' => 'numbers',
				],
			]
		);

		//dots-background
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'bwdcp_dots_background_color',
				'label' => esc_html__( 'Background', 'bwdcp-catproduct-td' ),
				'types' => [ 'classic', 'gradient'],
				'selector' => '{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot',
			]
		);

		//dots-typography
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'bwdcp_dots_number_typography',
				'selector' => '{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot span',
				'condition' => [
					'bwdcp_dots_type' => 'numbers',
				],
			]
		);

		//width
		$this->add_responsive_control(
			'bwdcp_dots_width',
			[
				'label' => esc_html__( 'Width', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot ' => 'inline-size: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//height
		$this->add_responsive_control(
			'bwdcp_dots_height',
			[
				'label' => esc_html__( 'Height', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot' => 'block-size: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//border
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdcp_dots_border',
				'label' => esc_html__( 'Border', 'bwdcp-catproduct-td' ),
				'selector' => '{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot',
			]
		);

		//Border Radius
		$this->add_responsive_control(
			'bwdcp_dots_border-radius',
			[
				'label' => esc_html__( 'Border Radius', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		//Box Shadow
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'bwdcp_dots_box-shadow',
				'label' => esc_html__( 'Box Shadow', 'bwdcp-catproduct-td' ),
				'selector' => '{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot',
			]
		);


		$this->end_controls_tab();



		//highlight-active-style------------------------------------------
		$this->start_controls_tab(
			'style_active_tab_dots',
			[
				'label' => esc_html__( 'Active', 'bwdcp-catproduct-td' ),
			]
		);

		//dots-color
		$this->add_control(
			'bwdcp_dots_number_color_active',
			[
				'label' => esc_html__( 'Color', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot.active span' => 'color: {{VALUE}}',
				],
				'condition' => [
					'bwdcp_dots_type' => 'numbers',
				],
			]
		);

		//dots-background
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'bwdcp_dots_background_color_active',
				'label' => esc_html__( 'Background', 'bwdcp-catproduct-td' ),
				'types' => [ 'classic', 'gradient'],
				'selector' => '{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot.active',
			]
		);

		//dots-typography
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'bwdcp_dots_number_typography_active',
				'selector' => '{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot.active span',
				'condition' => [
					'bwdcp_dots_type' => 'numbers',
				],
			]
		);

		//width
		$this->add_responsive_control(
			'bwdcp_dots_width_active',
			[
				'label' => esc_html__( 'Width', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot.active' => 'inline-size: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//height
		$this->add_responsive_control(
			'bwdcp_dots_height_active',
			[
				'label' => esc_html__( 'Height', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot.active' => 'block-size: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//border
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdcp_dots_border_active',
				'label' => esc_html__( 'Border', 'bwdcp-catproduct-td' ),
				'selector' => '{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot.active',
			]
		);

		//Border Radius
		$this->add_responsive_control(
			'bwdcp_dots_border-radius_active',
			[
				'label' => esc_html__( 'Border Radius', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot.active' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		//Box Shadow
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'bwdcp_dots_box-shadow-active',
				'label' => esc_html__( 'Box Shadow', 'bwdcp-catproduct-td' ),
				'selector' => '{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot.active',
			]
		);

		$this->end_controls_tab();



		//highlight-hover-style------------------------------------------
		$this->start_controls_tab(
			'style_hover_tab_dots',
			[
				'label' => esc_html__( 'Hover', 'bwdcp-catproduct-td' ),
			]
		);

		//dots-color
		$this->add_control(
			'bwdcp_dots_number_color_hover',
			[
				'label' => esc_html__( 'Color', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot:hover span' => 'color: {{VALUE}}',
				],
				'condition' => [
					'bwdcp_dots_type' => 'numbers',
				],
			]
		);

		//dots-background
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'bwdcp_dots_background_color_hover',
				'label' => esc_html__( 'Background', 'bwdcp-catproduct-td' ),
				'types' => [ 'classic', 'gradient'],
				'selector' => '{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot:hover',
			]
		);

		//dots-typography
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'bwdcp_dots_number_typography_hover',
				'selector' => '{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot:hover span',
				'condition' => [
					'bwdcp_dots_type' => 'numbers',
				],
			]
		);

		//width
		$this->add_responsive_control(
			'bwdcp_dots_width_hover',
			[
				'label' => esc_html__( 'Width', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot:hover' => 'inline-size: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//height
		$this->add_responsive_control(
			'bwdcp_dots_height_hover',
			[
				'label' => esc_html__( 'Height', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot:hover' => 'block-size: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//border
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdcp_dots_border_hover',
				'label' => esc_html__( 'Border', 'bwdcp-catproduct-td' ),
				'selector' => '{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot:hover',
			]
		);

		//Border Radius
		$this->add_responsive_control(
			'bwdcp_dots_border-radius_hover',
			[
				'label' => esc_html__( 'Border Radius', 'bwdcp-catproduct-td' ),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot:hover' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		//Box Shadow
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'bwdcp_dots_box-shadow-hover',
				'label' => esc_html__( 'Box Shadow', 'bwdcp-catproduct-td' ),
				'selector' => '{{WRAPPER}} .bwdcp-owl-dots .bwdcp-owl-dot:hover',
			]
		);

		$this->end_controls_tab();
		$this->end_controls_tabs();

		$this->end_controls_section();

	}

	protected function render() {
		$settings = $this->get_settings_for_display();

		// for-owl-carousel-start
		$bwdcp_slide_margin = $settings['bwdcp_slide_margin'];
		$bwdcp_slide_mobile_view = $settings['bwdcp_slide_mobile_view'];
		$bwdcp_slide_tablet_view = $settings['bwdcp_slide_tablet_view'];
		$bwdcp_slide_desktop_view = $settings['bwdcp_slide_desktop_view'];
		$bwdcp_infinite_autoplay_switcher = $settings['bwdcp_infinite_autoplay_switcher'];
		$bwdcp_infinite_loop_switcher = $settings['bwdcp_infinite_loop_switcher'];
		$bwdcp_HoverPause_switcher = $settings['bwdcp_HoverPause_switcher'];
		$bwdcp_centermode_switcher = $settings['bwdcp_centermode_switcher'];
		$bwdcp_autoplay_timeout = $settings['bwdcp_autoplay_timeout'];
		$bwdcp_autoplay_speed = $settings['bwdcp_autoplay_speed'];
		$bwdcp_stace_padding = $settings['bwdcp_stace_padding'];
		//nav--------------------------------------------------
		$bwdcp_nav_switcher = $settings['bwdcp_nav_switcher'];
		$bwdcp_nav_type = $settings['bwdcp_nav_type'];

		if( $bwdcp_nav_switcher == 'yes' ) {
			if( $bwdcp_nav_type == 'icon' ) {
				$prev = $settings['bwdcp_nav_prev_arrow']['value'];
				$next = $settings['bwdcp_nav_next_arrow']['value'];
			} else if( $bwdcp_nav_type == 'text' ) {
				$prev = $settings['bwdcp_nav_prev_text'];
				$next = $settings['bwdcp_nav_next_text'];
			} 
		}
		$bwdcp_dots_switcher = $settings['bwdcp_dots_switcher'];
		$bwdcp_dots_type = $settings['bwdcp_dots_type'];
		// for-owl-carousel-end

		$bwdcp_cat_image = $settings['bwdcp_image'];
		$bwdcp_cat_image_link = $settings['bwdcp_image_link'];
		$bwdcp_cat_title = $settings['bwdcp_title'];
		$bwdcp_cat_description = $settings['bwdcp_description'];
		$bwdcp_cat_button = $settings['bwdcp_button'];
		$bwdcp_button_text = $settings['bwdcp_button_text'];
	
		$bwdcp_the_cat_filter = $settings['bwdcp_the_cat_filter'];
		$bwdcp_orderby = $settings['bwdcp_the_order_by'];
		$bwdcp_order_only = $settings['bwdcp_blog_order'];
		$bwdcp_empty_cat = $settings['bwdcp_empty_cat'];
	
		$bwdcp_exclude_text = $settings['bwdcp_product_exclude_categories'];
		$bwdcp_include_text = $settings['bwdcp_product_include_categories'];
	
		$product_args = [
			"taxonomy" => "product_cat",
			"orderby" => $bwdcp_orderby,
			"hide_empty" => ( 'yes' === $bwdcp_empty_cat ) ? false : true,
			"order" => $bwdcp_order_only,
			'exclude' => $bwdcp_exclude_text,
			'include' => $bwdcp_include_text,
		];
		$product_parent_args = [
			"taxonomy" => "product_cat",
			"orderby" => $bwdcp_orderby,
			"hide_empty" => ( 'yes' === $bwdcp_empty_cat ) ? false : true,
			"order" => $bwdcp_order_only,
			'exclude' => $bwdcp_exclude_text,
			'include' => $bwdcp_include_text,
			"parent" => 0,
		];
		$product_cat_args = ( 'top_label' === $bwdcp_the_cat_filter ) ? $product_parent_args : $product_args;
		$categories = get_terms($product_cat_args);
	
		function get_category_average_rating($category_id) {
            $args = array(
                'post_type' => 'product',
                'posts_per_page' => -1,
                'tax_query' => array(
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $category_id,
                    ),
                ),
            );
            $query = new \WP_Query($args);

            $total_rating = 0;
            $total_reviews = 0;

            if ($query->have_posts()) {
                while ($query->have_posts()) {
                    $query->the_post();
                    global $product;
                    $rating_count = $product->get_rating_count();
                    $average_rating = $product->get_average_rating();

                    if ($rating_count > 0) {
                        $total_rating += $average_rating * $rating_count;
                        $total_reviews += $rating_count;
                    }
                }
                wp_reset_postdata();
            }

            if ($total_reviews > 0) {
                $average_rating = $total_rating / $total_reviews;
            } else {
                $average_rating = 0;
            }

            return round($average_rating, 2);
        }

        function get_category_total_reviews($category_id) {
            $args = array(
                'post_type' => 'product',
                'posts_per_page' => -1,
                'tax_query' => array(
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $category_id,
                    ),
                ),
            );

            $query = new \WP_Query($args);

            $total_reviews = 0;

            if ($query->have_posts()) {
                while ($query->have_posts()) {
                    $query->the_post();
                    global $product;
                    $total_reviews += $product->get_review_count();
                }
                wp_reset_postdata();
            }

            return $total_reviews;
        }
	
		$bwdcp_style_selection = $settings['bwdcp_select_style_selection'];

		if ($bwdcp_style_selection) { ?>
			<div class="bwdcp_catagory_<?php echo $bwdcp_style_selection ?> bwdcp-slider-common <?php echo esc_attr($settings['bwdcp_dots_type_style']); ?>" id="<?php echo esc_attr($settings['bwdcp-catproduct-custom-id']); ?>">
				<?php require 'bwdcp-variable.php'; ?>
				<div class="bwdcp-owl bwdcp-owl-carousel bwdcp-owl-theme">
					<?php if ($categories == true) {
						foreach ($categories as $category) {
							$category_id = $category->term_id;
							$average_rating = get_category_average_rating($category_id); ?>
							<div class="bwdcp-item bwdcp_cat_box_common">
								<div class="bwdcp_catagory-wrap">
									<?php if ('yes' === $bwdcp_cat_image) { ?>
										<div class="bwdcp_catagory-img bwdcp_cat_h_bg bwdcp_cat_n_bg">
											<?php
											$thumbnail_id = get_term_meta($category->term_id, "thumbnail_id", true);
											$image = wp_get_attachment_url($thumbnail_id);
											if ('yes' === $bwdcp_cat_image_link) { ?><a href="<?php echo esc_url(get_category_link($category->term_id)); ?>"><?php } ?><?php if ($thumbnail_id == true) { ?><img src="<?php echo esc_url($image); ?>"><?php } else {
												echo '<h1>' . esc_html__('Add Category Image') . '</h1>';
											} ?><?php if ($bwdcp_style_selection === '5') { ?> <div class="bwdcp_extra-content bwdcp_catagory_image_overlay"> <?php if ('yes' === $bwdcp_cat_title) { ?> <div class="bwdcp_catagory-title"><?php echo esc_attr($category->name); ?> (<?php echo esc_attr($category->count); ?>)</div><?php } ?></div><?php } ?><?php if ($bwdcp_style_selection === '4') { ?><div class="bwdcp_extra-content bwdcp_catagory_image_overlay">
													<?php if ('yes' === $bwdcp_cat_description) { ?><div class="bwdcp_catagory-disce"><?php echo esc_attr($category->description); ?></div><?php } ?></div><?php } ?></a></div><?php } ?><div class="bwdcp_catacory-content"><?php if ('yes' === $bwdcp_cat_title) { ?><?php if ($bwdcp_style_selection !== '5') { ?>
												<a href="<?php echo esc_url(get_category_link($category->term_id)); ?>"><div class="bwdcp_catagory-title"><?php echo esc_attr($category->name); ?> (<?php echo esc_attr($category->count); ?>)</div></a><?php } ?><?php } ?>
										<?php if ('yes' === $settings['bwdcp_review']) { ?><div class="category-average-rating">
												<?php
												$average_rating = get_category_average_rating($category_id);
												$total_reviews = get_category_total_reviews($category_id);
		
												if ($average_rating > 0) {
													for ($i = 1; $i <= 5; $i++) {
														if ($i <= $average_rating) {
															echo '<i class="fas fa-star"></i>';
														} else if ($i - 0.5 == $average_rating) {
															echo '<i class="fas fa-star-half-alt"></i>';
														} else {
															echo '<i class="far fa-star"></i>';
														}
													}
													if ('yes' === $settings['bwdcp_review_number']) {
														echo ' <span class="bwdcp_review_count">(' . $total_reviews . ')</span>';
													}
												} ?>
											</div><?php } ?>
										<?php if ('yes' === $bwdcp_cat_description) { ?>
											<?php if ($bwdcp_style_selection !== '4') { ?>
												<div class="bwdcp_catagory-disce"><?php echo esc_attr($category->description); ?></div><?php } ?>
										<?php } ?><?php if ('yes' === $bwdcp_cat_button) { ?><div class="bwdcp_catagory-bttn"><a class="bwdcp_Cbutton" href="<?php echo esc_url(get_category_link($category->term_id)); ?>"><?php echo esc_html__($bwdcp_button_text); ?></a></div><?php } ?>
									</div>
								</div>
							</div>
						<?php }
					} else {
						echo '<div class="bwdcp_none_product">' . esc_html__('You don\'t have any products. Please add your products.') . '</div>';
					} ?>
				</div>
			</div><?php
		}
		
		
	}
	
}
